require 'active_interaction'
require 'roqua/core_api/version'
require 'roqua/core_api/sessions'
require 'roqua/core_api/models'
require 'roqua/core_api/base'

module Roqua
  module CoreApi
    extend ActiveSupport::Autoload
    # Raised when a request failed due to an expired/non-existant session.
    class NoSession < StandardError; end
    class Unauthorized < StandardError; end

    autoload :CreateDossier
    autoload :CreateDossierGroup
    autoload :CreateDossierGroupExportSynchronously
    autoload :CreateProfessional
    autoload :CreateTokenSession
    autoload :DestroyTokenSession
    autoload :Dossiers
    autoload :DossierGroups
    autoload :DeleteDossierGroupRight
    autoload :ListDossierGroupRights
    autoload :People
    autoload :Person
    autoload :SendEmailTo
    autoload :SendNotification
    autoload :SendTextMessageTo
    autoload :SendInviteEmail
    autoload :SsoLogin
    autoload :UpdatePerson
    autoload :UpdateDossier

    def self.load_fabricators
      gem_root = Gem::Specification.find_by_name("roqua-core-api").gem_dir
      Fabrication::Config.path_prefixes << gem_root unless Fabrication::Config.path_prefixes.include? gem_root
    end
  end
end
