module Roqua
  module CoreApi
    class Base < ActiveInteraction::Base
      private

      def create_enum(headers, rows)
        row_class = Struct.new(*headers.map(&:to_sym))
        rows.lazy.map { |row| row_class.new(*row) }.to_enum
      end

      def errors_to_object(response, obj)
        (response['errors'][obj.class.name.demodulize.underscore] || []).each do |attribute, errors|
          errors.each do |error|
            obj.errors.add(attribute.to_sym, error.to_sym)
          end
        end
      end

      def errors_to_usecase(response)
        (response['errors'] || []).each do |attribute, resp_errors|
          resp_errors.each do |error|
            errors.add(attribute.to_sym, error.to_sym)
          end
        end
      end
    end
  end
end
