module Roqua
  module CoreApi
    # @api private
    class CreateProfessional < Base
      object :session, class: Sessions::AuthSession
      string :dossier_group_id
      object :person, class: Models::Person
      string :email_subject, default: nil
      string :email_body, default: nil

      def execute
        response = session.post "/dossier_groups/#{dossier_group_id}/people", params
        if response.code == 422
          errors_to_object(response, person)
          person
        else
          Models::Person.new(response['person'])
        end
      end

      def params
        {
          person: person.as_json,
          email_subject: email_subject, email_body: email_body
        }.delete_if { |k, v| v.nil? }
      end
    end
  end
end
