module Roqua
  module CoreApi
    # @api private
    class Dossiers < Base
      object :session, class: Sessions::AuthSession
      string :dossier_group_id, default: nil
      string :with_name, default: nil
      string :with_external_identifier, default: nil

      validates :dossier_group_id, presence: true, if: -> { with_external_identifier.present? }

      # usage:
      # Roqua.CoreApi.Dossiers.run!.each do |d|
      #   puts d.id, d.birth_year, d.gender, d.firstname, d.lastname
      # end
      def execute
        response = session.get "#{url_prefix}/dossiers", params
        create_enum(response['headers'], response['rows'])
      end

      def url_prefix
        dossier_group_id.present? ? "/dossier_groups/#{dossier_group_id}" : ''
      end

      def params
        {name: with_name,
         external_identifier: with_external_identifier
        }.delete_if { |k, v| v.nil? }
      end
    end
  end
end
