module Roqua
  module CoreApi
    # @api private
    class SendInviteEmail < ActiveInteraction::Base
      object :session, class: Sessions::AuthSession
      string :dossier_id, default: nil
      string :person_id, default: nil
      string :email_subject, default: nil
      string :email_body, default: nil

      validates :person_id, presence: true, if: -> { dossier_id.nil? }

      def execute
        session.post url, params
      end

      private

      def url
        if person_id
          "/people/#{person_id}/send_invite_email"
        else
          "/dossiers/#{dossier_id}/send_invite_email"
        end
      end

      def params
        {
          email_subject: email_subject, email_body: email_body
        }.delete_if { |k, v| v.nil? }
      end
    end
  end
end
