module Roqua
  module CoreApi
    # @api private
    class SendNotification < ActiveInteraction::Base
      string :person_id, default: nil # if nil, to must be present.
      string :dossier_id, default: nil
      hash :attributes do
        string :body_short
        string :body_long
        string :notification_type, default: nil
        string :reference
        string :subject
        hash :addresses, default: nil, strip: false
        hash :variables, strip: false, default: {}
        array :notify_by do # [:sms, :email]
          string
        end
      end

      # Possible variables in the body/subject are:
      #   %firstname%,
      #   %lastname%,
      #   %initials%
      def execute
        CoreApi.basic_auth_session.post "/notifications", notification: attributes,
                                                          person_id: person_id,
                                                          dossier_id: dossier_id
      end
    end
  end
end
