module Roqua
  module CoreApi
    # @api private
    class SendTextMessageTo < ActiveInteraction::Base
      object :session, class: Sessions::AuthSession
      string :person_id
      hash :attributes do
        string :body
        string :reference, default: nil
      end

      # Possible variables in the body are:
      #   %firstname%,
      #   %lastname%,
      #   %initials%
      def execute
        session.post "/text_messages", text_message: attributes, person_id: person_id
      end
    end
  end
end
