module Roqua
  module CoreApi
    module Sessions
      class BasicAuthSession < AuthSession
        attr_reader :username
        attr_reader :password

        def initialize(username: ENV.fetch('CORE_BASICAUTH_ID'),
                       password: ENV.fetch('CORE_BASICAUTH_SECRET'),
                       **additional_arguments)
          @username = username
          @password = password
          super(**additional_arguments)
        end

        private

        # handle 401 response.
        def access_denied(response)
          if response.headers['WWW-Authenticate']
            fail 'basic auth for core invalid'
          else
            fail Unauthorized
          end
        end

        def basic_auth
          {username: username, password: password}
        end
      end
    end
  end
end
