module Roqua
  module CoreApi
    module Sessions
      class HmacAuthSession < AuthSession
        attr_reader :consumer_key, :consumer_secret

        delegate :headers, :access_denied, to: :hmac_auth_request

        def initialize(consumer_key: ENV.fetch('CORE_CONSUMER_KEY'),
                       consumer_secret: ENV.fetch('CORE_CONSUMER_SECRET'),
                       **additional_arguments)
          @consumer_key = consumer_key
          @consumer_secret = consumer_secret
          super(**additional_arguments)
        end

        private

        def hmac_auth_request
          HmacAuthRequest.new(consumer_key: consumer_key, consumer_secret: consumer_secret)
        end
      end
    end
  end
end
