module Roqua
  module CoreApi
    # @api private
    class SsoLogin < Base
      object :session, class: Sessions::AuthSession
      string :organization_id
      string :dossier_group_id
      string :external_identifier
      hash :extra_params, strip: false, default: {}

      def execute
        response = session.get "/sso/login", **sso_params
        if response.code == 422
          errors_to_usecase response
        end
        response['token_session']
      end

      def sso_params
        extra_params.merge(
          organization_id: organization_id,
          dossier_group_id: dossier_group_id,
          external_identifier: external_identifier
        ).symbolize_keys
      end
    end
  end
end
